/******************************************************************************
*
* project name:    Scorch
* file name:       Ai##.c
* initial date:    27.12.2004
* author:          mhubi@freesurf.ch
* description:     artifical intelligence stuff
*
*******************************************************************************
*
* Scorch -- another tank-game
* Copyright (C) 2004  Martin Huber
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/

#include "main-h13.h"


void AiMain(TARGET *target, unsigned int status) {
	
	unsigned int num, ennemi;
	int direction = 0;
	
	int delta_x;
	
	num = game->pl_active;
	ennemi = player[num].target;
	
	if (status == PRE) {
		
		if (player[num].strength == 1) {
			
			player[num].power = 1 + random(100);
			
		}
		
		else if (player[num].strength >= 2) {
			
			if (player[ennemi].life == 0) {
				ChooseEnnemi(num, TRUE);
			}
			
			ChooseArmor(num);
			
		}
		
	}
	else if (status == AFTER) {
		
		if (player[num].strength == 1 && random(10) == 0) {
			
			player[num].angle = 1 + random(180);
			player[num].angle_img = player[num].angle;
			
		}
		else if (player[num].strength >= 2) {
			
			if (num < player[num].target) {
				direction = 1;
			}
			else if (num > player[num].target) {
				direction = -1;
			}
			
			
			if (player[ennemi].health <= 0) {
				ChooseEnnemi(num, TRUE);
			}
			else if (player[num].power == 100) {
				ChooseEnnemi(num, TRUE);
			}
			else {
				
				delta_x = (player[ennemi].x - target->x)*direction;
				player[num].power += (int)delta_x/4;
				
				if (delta_x < 15 && player[num].bomb[0] == 1) {
					ChooseWeapon(num);
				}
				
			}
			
			
			if (player[num].power < 0) {
				player[num].power = 10 + random(10);
			}
			else if (player[num].power > 100) {
				player[num].power = 100;
			}
			
		}
		
	}
	
	
}

void ChooseEnnemi(unsigned int num, int mode) {
	
	unsigned int ennemi;
	BOOL human = FALSE;
	
	player[num].bomb[0] = 1;
	
	if (player[num].strength == 1) {
		
		player[num].target = 10;
		
	}
	
	else if (player[num].strength >= 2) {
		
		if (player[num].strength == 4 || player[num].strength == 6) {
			human = CheckHuman();
		}
		
		do {
			
			ennemi = random(game->pl_num);
			
			if ((player[num].strength == 4 || player[num].strength == 6) && human == TRUE && player[ennemi].type != 1) {
				ennemi = num;
			}
			
		} while ((ennemi == num && mode == FALSE) || 
						 (mode == TRUE && (ennemi == num || player[ennemi].health <= 0)));
		
		
		player[num].target = ennemi;
		
		if (player[num].strength == 2) {
			if (num < ennemi) {
				player[num].angle = 45;
			}
			else if (num > ennemi) {
				player[num].angle = 135;
			}
		}
		else if (player[num].strength >= 3) {
			ChooseAngle(num, ennemi);
		}
		
		
		player[num].angle_img = player[num].angle;
		
		if (mode == TRUE) {
			Tube(num);
		}
		
		player[num].power = ABS(player[num].x - player[ennemi].x)/3;
	
	}
	
	
}

void AiShop(void) {
	
	unsigned int num, possible, choose;
	unsigned int itemlist[MERCH - 1];
	
	num = game->pl_check;
	possible = 0;
	choose = 0;
	
	if (player[num].strength == 1) {
		return;
	}
	else if (player[num].strength >= 2 && player[num].credits >= 1000) {
		
		do {
			
			possible = BuildItemList(itemlist, player[num].credits);
			
			//choose = random(possible);
			
			choose = itemlist[random(possible)];
			
			player[num].credits -= bomb_skill[choose][1];
			player[num].bomb[choose + 1] += bomb_skill[choose][0];
			
		} while (player[num].credits >= 1000);
		
		#if defined(TESTING)
		Inventory(num);
		#endif
		
	}
	
}

unsigned int BuildItemList(unsigned int *itemlist, unsigned int credit) {
	
	unsigned int loop1, items;
	
	items = 0;
	
	for (loop1 = 1; loop1 < MERCH; loop1++) {
		
		if (bomb_skill[loop1][1] <= credit) {
			
			itemlist[items] = loop1;
			
			items++;
			
		}
		
	}
	
	return items;
	
}


void ChooseWeapon(unsigned int num) {
	
	unsigned int randitem, loops;
	
	loops = 0;
	
	do {
		
		
		do {
			randitem = 2 + random(MONSTERDIGGER - 1);
		} while (randitem == LASERLITTLE || randitem == LASERBIG);
		
		loops++;
		
	} while (player[num].bomb[randitem] == 0 && loops < 10);
	
	if (loops < 10) {
		player[num].bomb[0] = randitem;
	}
	
}


void ChooseArmor(unsigned int num) {
	
	if (player[num].health < 10 && player[num].bomb[BATTERY] != 0) {
		
		do {
			
			player[num].health++;
			player[num].bomb[BATTERY]--;
			
		} while (player[num].health < 10 && player[num].bomb[BATTERY] != 0);
		
	}
	
	if (player[num].protect != PARACHUTE && player[num].bomb[PARACHUTE] != 0) {
		
		player[num].protect = PARACHUTE;
		player[num].bomb[PARACHUTE]--;
		
	}
	
	if (player[num].bomb[SHIELDBIG] != 0 && player[num].shield < 15) {
		
		player[num].shield = 30;
		player[num].bomb[SHIELDBIG]--;
		
	}
	else if (player[num].bomb[SHIELDLITTLE] != 0 && player[num].shield < 5) {
		
		player[num].shield = 10;
		player[num].bomb[SHIELDLITTLE]--;
		
	}	
		
}


void ChooseAngle(unsigned int num, unsigned int ennemi) {
	
	int loop1;
	int factor = 1;
	float max = 0, quot = 0, angle = 90;
	
	if (num < ennemi) {
		factor = 1;
		angle = 0;
		max = 1;
	}
	else if (num > ennemi) {
		factor = -1;
		angle = 180;
		max = -1;
	}
	
	for (loop1 = player[num].x; loop1 != player[ennemi].x; loop1 += (1*factor)) {
		
		if (earth[loop1] < player[num].y) {
			
			quot = ((float)(player[num].y - earth[loop1])/(float)(loop1 - player[num].x));
			
			if ((factor == 1 && quot > max) || (factor == -1 && quot < max)) {
				max = quot;
			}
			
			
			
		}
		
	}
	
	angle = arctan_deg(max);
	
	if (angle < 0) {
		angle += 180;
	}
	
	if (angle > 45 && angle < 135) {
		if (ABS(90 - angle) >= 5) {
			angle += (5*factor);
		}
		else {
			angle = 90 - factor*(random(3) + 2);
		}
	}
	
	player[num].angle = angle;
	
}

BOOL CheckHuman(void) {
	
	BOOL human = FALSE;
	unsigned int loop1;
	
	for (loop1 = 0; loop1 < game->pl_num; loop1++) {
		if (player[loop1].type == 1 && player[loop1].health > 0) {
			human = TRUE;
		}
	}
	
	return human;
	
}

void ForceChooseEnnemi(unsigned int num) {
	
	if (player[num].target != game->pl_active && player[player[num].target].target != num
			&& game->pl_active != num && player[num].health > 0) {
		
		player[num].target = game->pl_active;
		
		ChooseAngle(num, game->pl_active);
		
		player[num].angle_img = player[num].angle;
		
		Tube(num);
		
		player[num].power = ABS(player[num].x - player[game->pl_active].x)/3;
		
	}
	
}
/*void Aidata(void) {
	
	GrayClearScreen();
	
	MoveTo(0, 0);
	
	printf("x0 = %d\n", player[0].x);
	printf("y0 = %d\n", player[0].y);
	printf("x  = %d\n", player[1].x);
	printf("y  = %d\n", player[1].y);
	printf("w  = %d\n", game.wind);
	printf("t  = %f\n", player[0].time);
	
	Waitkey();
	
	GrayClearScreen();
	//@@@@
	DrawScreen();
	
}*/

//ti89 version: completely done